package net.vtstar.zhongtong.avi.monitoring.domain;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

@ApiModel("平移车")
@Data
public class Vehicle {

    private Long id;

    @ApiModelProperty(notes = "别名（平移车号）")
    private String alias;

    @ApiModelProperty(notes = "所属平移车道（从东向西（1,2,3,4））")
    private Integer lane;

    @ApiModelProperty(notes = " 转动：正转（true），反转（false）")
    private Boolean turn;

    @ApiModelProperty(notes = "rfid信息")
    private String code;

    @ApiModelProperty(notes = "左侧有无车信号")
    private Boolean leftSignal;

    @ApiModelProperty(notes = "右侧有无车信号")
    private Boolean rightSignal;

    @ApiModelProperty(notes = "当前左侧所在车道")
    private String leftLane;

    @ApiModelProperty(notes = "当前右侧所在车道")
    private String rightLane;

    @ApiModelProperty(notes = "Rfid上下车信号，上车 1， 下车0")
    private Boolean state;

    @ApiModelProperty(notes = "当前绑定滑撬")
    private String currentRfid;
}
